diff --git a/drivers/raw/Makefile b/drivers/raw/Makefile
index c1b85c8c7..fd1352a9d 100644
--- a/drivers/raw/Makefile
+++ b/drivers/raw/Makefile
@@ -4,12 +4,12 @@
 include $(RTE_SDK)/mk/rte.vars.mk
 
 # DIRS-$(<configuration>) += <directory>
-DIRS-$(CONFIG_RTE_LIBRTE_PMD_SKELETON_RAWDEV) += skeleton_rawdev
+DIRS-$(CONFIG_RTE_LIBRTE_PMD_SKELETON_RAWDEV) += skeleton
 ifeq ($(CONFIG_RTE_EAL_VFIO)$(CONFIG_RTE_LIBRTE_FSLMC_BUS),yy)
 DIRS-$(CONFIG_RTE_LIBRTE_PMD_DPAA2_CMDIF_RAWDEV) += dpaa2_cmdif
 DIRS-$(CONFIG_RTE_LIBRTE_PMD_DPAA2_QDMA_RAWDEV) += dpaa2_qdma
 endif
-DIRS-$(CONFIG_RTE_LIBRTE_PMD_IFPGA_RAWDEV) += ifpga_rawdev
+DIRS-$(CONFIG_RTE_LIBRTE_PMD_IFPGA_RAWDEV) += ifpga
 DIRS-$(CONFIG_RTE_LIBRTE_PMD_IOAT_RAWDEV) += ioat
 
 include $(RTE_SDK)/mk/rte.subdir.mk
diff --git a/drivers/raw/ifpga_rawdev/Makefile b/drivers/raw/ifpga/Makefile
similarity index 86%
rename from drivers/raw/ifpga_rawdev/Makefile
rename to drivers/raw/ifpga/Makefile
index f60b547d8..5fa9303d5 100644
--- a/drivers/raw/ifpga_rawdev/Makefile
+++ b/drivers/raw/ifpga/Makefile
@@ -21,13 +21,13 @@ LDLIBS += -lrte_kvargs
 LDLIBS += -lrte_bus_pci
 LDLIBS += -lrte_bus_ifpga
 
-EXPORT_MAP := rte_pmd_ifpga_rawdev_version.map
+EXPORT_MAP := rte_pmd_ifpga_version.map
 
 LIBABIVER := 1
 
 VPATH += $(SRCDIR)/base
 
-include $(RTE_SDK)/drivers/raw/ifpga_rawdev/base/Makefile
+include $(RTE_SDK)/drivers/raw/ifpga/base/Makefile
 
 #
 # all source are stored in SRCS-y
diff --git a/drivers/raw/ifpga_rawdev/base/Makefile b/drivers/raw/ifpga/base/Makefile
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/Makefile
rename to drivers/raw/ifpga/base/Makefile
diff --git a/drivers/raw/ifpga_rawdev/base/README b/drivers/raw/ifpga/base/README
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/README
rename to drivers/raw/ifpga/base/README
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_api.c b/drivers/raw/ifpga/base/ifpga_api.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_api.c
rename to drivers/raw/ifpga/base/ifpga_api.c
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_api.h b/drivers/raw/ifpga/base/ifpga_api.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_api.h
rename to drivers/raw/ifpga/base/ifpga_api.h
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_compat.h b/drivers/raw/ifpga/base/ifpga_compat.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_compat.h
rename to drivers/raw/ifpga/base/ifpga_compat.h
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_defines.h b/drivers/raw/ifpga/base/ifpga_defines.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_defines.h
rename to drivers/raw/ifpga/base/ifpga_defines.h
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_enumerate.c b/drivers/raw/ifpga/base/ifpga_enumerate.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_enumerate.c
rename to drivers/raw/ifpga/base/ifpga_enumerate.c
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_enumerate.h b/drivers/raw/ifpga/base/ifpga_enumerate.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_enumerate.h
rename to drivers/raw/ifpga/base/ifpga_enumerate.h
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_feature_dev.c b/drivers/raw/ifpga/base/ifpga_feature_dev.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_feature_dev.c
rename to drivers/raw/ifpga/base/ifpga_feature_dev.c
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_feature_dev.h b/drivers/raw/ifpga/base/ifpga_feature_dev.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_feature_dev.h
rename to drivers/raw/ifpga/base/ifpga_feature_dev.h
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_fme.c b/drivers/raw/ifpga/base/ifpga_fme.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_fme.c
rename to drivers/raw/ifpga/base/ifpga_fme.c
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_fme_dperf.c b/drivers/raw/ifpga/base/ifpga_fme_dperf.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_fme_dperf.c
rename to drivers/raw/ifpga/base/ifpga_fme_dperf.c
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_fme_error.c b/drivers/raw/ifpga/base/ifpga_fme_error.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_fme_error.c
rename to drivers/raw/ifpga/base/ifpga_fme_error.c
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_fme_iperf.c b/drivers/raw/ifpga/base/ifpga_fme_iperf.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_fme_iperf.c
rename to drivers/raw/ifpga/base/ifpga_fme_iperf.c
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_fme_pr.c b/drivers/raw/ifpga/base/ifpga_fme_pr.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_fme_pr.c
rename to drivers/raw/ifpga/base/ifpga_fme_pr.c
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_hw.h b/drivers/raw/ifpga/base/ifpga_hw.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_hw.h
rename to drivers/raw/ifpga/base/ifpga_hw.h
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_port.c b/drivers/raw/ifpga/base/ifpga_port.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_port.c
rename to drivers/raw/ifpga/base/ifpga_port.c
diff --git a/drivers/raw/ifpga_rawdev/base/ifpga_port_error.c b/drivers/raw/ifpga/base/ifpga_port_error.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/ifpga_port_error.c
rename to drivers/raw/ifpga/base/ifpga_port_error.c
diff --git a/drivers/raw/ifpga_rawdev/base/meson.build b/drivers/raw/ifpga/base/meson.build
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/meson.build
rename to drivers/raw/ifpga/base/meson.build
diff --git a/drivers/raw/ifpga_rawdev/base/opae_at24_eeprom.c b/drivers/raw/ifpga/base/opae_at24_eeprom.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_at24_eeprom.c
rename to drivers/raw/ifpga/base/opae_at24_eeprom.c
diff --git a/drivers/raw/ifpga_rawdev/base/opae_at24_eeprom.h b/drivers/raw/ifpga/base/opae_at24_eeprom.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_at24_eeprom.h
rename to drivers/raw/ifpga/base/opae_at24_eeprom.h
diff --git a/drivers/raw/ifpga_rawdev/base/opae_debug.c b/drivers/raw/ifpga/base/opae_debug.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_debug.c
rename to drivers/raw/ifpga/base/opae_debug.c
diff --git a/drivers/raw/ifpga_rawdev/base/opae_debug.h b/drivers/raw/ifpga/base/opae_debug.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_debug.h
rename to drivers/raw/ifpga/base/opae_debug.h
diff --git a/drivers/raw/ifpga_rawdev/base/opae_eth_group.c b/drivers/raw/ifpga/base/opae_eth_group.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_eth_group.c
rename to drivers/raw/ifpga/base/opae_eth_group.c
diff --git a/drivers/raw/ifpga_rawdev/base/opae_eth_group.h b/drivers/raw/ifpga/base/opae_eth_group.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_eth_group.h
rename to drivers/raw/ifpga/base/opae_eth_group.h
diff --git a/drivers/raw/ifpga_rawdev/base/opae_hw_api.c b/drivers/raw/ifpga/base/opae_hw_api.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_hw_api.c
rename to drivers/raw/ifpga/base/opae_hw_api.c
diff --git a/drivers/raw/ifpga_rawdev/base/opae_hw_api.h b/drivers/raw/ifpga/base/opae_hw_api.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_hw_api.h
rename to drivers/raw/ifpga/base/opae_hw_api.h
diff --git a/drivers/raw/ifpga_rawdev/base/opae_i2c.c b/drivers/raw/ifpga/base/opae_i2c.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_i2c.c
rename to drivers/raw/ifpga/base/opae_i2c.c
diff --git a/drivers/raw/ifpga_rawdev/base/opae_i2c.h b/drivers/raw/ifpga/base/opae_i2c.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_i2c.h
rename to drivers/raw/ifpga/base/opae_i2c.h
diff --git a/drivers/raw/ifpga_rawdev/base/opae_ifpga_hw_api.c b/drivers/raw/ifpga/base/opae_ifpga_hw_api.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_ifpga_hw_api.c
rename to drivers/raw/ifpga/base/opae_ifpga_hw_api.c
diff --git a/drivers/raw/ifpga_rawdev/base/opae_ifpga_hw_api.h b/drivers/raw/ifpga/base/opae_ifpga_hw_api.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_ifpga_hw_api.h
rename to drivers/raw/ifpga/base/opae_ifpga_hw_api.h
diff --git a/drivers/raw/ifpga_rawdev/base/opae_intel_max10.c b/drivers/raw/ifpga/base/opae_intel_max10.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_intel_max10.c
rename to drivers/raw/ifpga/base/opae_intel_max10.c
diff --git a/drivers/raw/ifpga_rawdev/base/opae_intel_max10.h b/drivers/raw/ifpga/base/opae_intel_max10.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_intel_max10.h
rename to drivers/raw/ifpga/base/opae_intel_max10.h
diff --git a/drivers/raw/ifpga_rawdev/base/opae_osdep.h b/drivers/raw/ifpga/base/opae_osdep.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_osdep.h
rename to drivers/raw/ifpga/base/opae_osdep.h
diff --git a/drivers/raw/ifpga_rawdev/base/opae_spi.c b/drivers/raw/ifpga/base/opae_spi.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_spi.c
rename to drivers/raw/ifpga/base/opae_spi.c
diff --git a/drivers/raw/ifpga_rawdev/base/opae_spi.h b/drivers/raw/ifpga/base/opae_spi.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_spi.h
rename to drivers/raw/ifpga/base/opae_spi.h
diff --git a/drivers/raw/ifpga_rawdev/base/opae_spi_transaction.c b/drivers/raw/ifpga/base/opae_spi_transaction.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/opae_spi_transaction.c
rename to drivers/raw/ifpga/base/opae_spi_transaction.c
diff --git a/drivers/raw/ifpga_rawdev/base/osdep_raw/osdep_generic.h b/drivers/raw/ifpga/base/osdep_raw/osdep_generic.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/osdep_raw/osdep_generic.h
rename to drivers/raw/ifpga/base/osdep_raw/osdep_generic.h
diff --git a/drivers/raw/ifpga_rawdev/base/osdep_rte/osdep_generic.h b/drivers/raw/ifpga/base/osdep_rte/osdep_generic.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/base/osdep_rte/osdep_generic.h
rename to drivers/raw/ifpga/base/osdep_rte/osdep_generic.h
diff --git a/drivers/raw/ifpga_rawdev/ifpga_rawdev.c b/drivers/raw/ifpga/ifpga_rawdev.c
similarity index 100%
rename from drivers/raw/ifpga_rawdev/ifpga_rawdev.c
rename to drivers/raw/ifpga/ifpga_rawdev.c
diff --git a/drivers/raw/ifpga_rawdev/ifpga_rawdev.h b/drivers/raw/ifpga/ifpga_rawdev.h
similarity index 100%
rename from drivers/raw/ifpga_rawdev/ifpga_rawdev.h
rename to drivers/raw/ifpga/ifpga_rawdev.h
diff --git a/drivers/raw/ifpga_rawdev/meson.build b/drivers/raw/ifpga/meson.build
similarity index 100%
rename from drivers/raw/ifpga_rawdev/meson.build
rename to drivers/raw/ifpga/meson.build
diff --git a/drivers/raw/ifpga_rawdev/rte_pmd_ifpga_rawdev_version.map b/drivers/raw/ifpga/rte_pmd_ifpga_version.map
similarity index 100%
rename from drivers/raw/ifpga_rawdev/rte_pmd_ifpga_rawdev_version.map
rename to drivers/raw/ifpga/rte_pmd_ifpga_version.map
diff --git a/drivers/raw/meson.build b/drivers/raw/meson.build
index 2af8a70d4..23dd3ccff 100644
--- a/drivers/raw/meson.build
+++ b/drivers/raw/meson.build
@@ -2,8 +2,8 @@
 # Copyright 2018 NXP
 
 drivers = ['dpaa2_cmdif', 'dpaa2_qdma',
-	'ifpga_rawdev', 'ioat',
-	'skeleton_rawdev']
+	'ifpga', 'ioat',
+	'skeleton']
 std_deps = ['rawdev']
 config_flag_fmt = 'RTE_LIBRTE_PMD_@0@_RAWDEV'
 driver_name_fmt = 'rte_pmd_@0@'
diff --git a/drivers/raw/skeleton_rawdev/Makefile b/drivers/raw/skeleton/Makefile
similarity index 91%
rename from drivers/raw/skeleton_rawdev/Makefile
rename to drivers/raw/skeleton/Makefile
index 3f97c2ee0..9641e6505 100644
--- a/drivers/raw/skeleton_rawdev/Makefile
+++ b/drivers/raw/skeleton/Makefile
@@ -15,7 +15,7 @@ LDLIBS += -lrte_rawdev
 LDLIBS += -lrte_bus_vdev
 LDLIBS += -lrte_kvargs
 
-EXPORT_MAP := rte_pmd_skeleton_rawdev_version.map
+EXPORT_MAP := rte_pmd_skeleton_version.map
 
 LIBABIVER := 1
 
diff --git a/drivers/raw/skeleton_rawdev/meson.build b/drivers/raw/skeleton/meson.build
similarity index 100%
rename from drivers/raw/skeleton_rawdev/meson.build
rename to drivers/raw/skeleton/meson.build
diff --git a/drivers/raw/skeleton_rawdev/rte_pmd_skeleton_rawdev_version.map b/drivers/raw/skeleton/rte_pmd_skeleton_version.map
similarity index 100%
rename from drivers/raw/skeleton_rawdev/rte_pmd_skeleton_rawdev_version.map
rename to drivers/raw/skeleton/rte_pmd_skeleton_version.map
diff --git a/drivers/raw/skeleton_rawdev/skeleton_rawdev.c b/drivers/raw/skeleton/skeleton_rawdev.c
similarity index 100%
rename from drivers/raw/skeleton_rawdev/skeleton_rawdev.c
rename to drivers/raw/skeleton/skeleton_rawdev.c
diff --git a/drivers/raw/skeleton_rawdev/skeleton_rawdev.h b/drivers/raw/skeleton/skeleton_rawdev.h
similarity index 100%
rename from drivers/raw/skeleton_rawdev/skeleton_rawdev.h
rename to drivers/raw/skeleton/skeleton_rawdev.h
diff --git a/drivers/raw/skeleton_rawdev/skeleton_rawdev_test.c b/drivers/raw/skeleton/skeleton_rawdev_test.c
similarity index 100%
rename from drivers/raw/skeleton_rawdev/skeleton_rawdev_test.c
rename to drivers/raw/skeleton/skeleton_rawdev_test.c